



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Configure swagger with spring boot</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Configure swagger with spring boot</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 18:49:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>If you haven&rsquo;t starting working with spring boot yet, you will quickly find that it pulls out all the common configuration from across your applications. Recently I helped in an effort to modularize configuration and worked on creating a spring-boot-swagger starter project. This project, like other boot modules, would be included in the pom and you would enjoy the fruits of auto configuration.</p>
<p>If you aren't familiar with swagger, swagger is a "specification and complete framework implementation for describing, producing, consuming, and visualizing RESTful web services". It has various integration points with java back end technologies (JAX-RS, scala, php, nodejs, etc) but even better it has separated the front end into a project called&nbsp;<a href="https://github.com/wordnik/swagger-ui" rel="external nofollow noreferrer">swagger-ui</a>. So as long as your service complies to the spec you can have a pretty UI on top of your rest services. It does lack official support spring MVC though there are various projects on github that attempt to integrate the two, even I&nbsp;<a href="https://github.com/justinmusgrove/swagger-spring" rel="external nofollow noreferrer">started a project</a>. Also there has been talk in&nbsp;<a href="https://jira.springsource.org/browse/XD-925?jql=text%20%7E%20%22swagger%22" rel="external nofollow noreferrer">spring&rsquo;s JIRA about swagger support</a>.</p>
<p>We went with&nbsp;<a href="https://github.com/martypitt/swagger-springmvc" rel="external nofollow noreferrer">swagger-springmc</a>&nbsp;simply due to the number of watchers/stars and it fit in pretty good with little effort. It can be integrated with traditional spring XML or through java config both ways requiring two properties to be set to specify the API version and the base path. With the direction of spring-boot, we wanted to abstract the dependency and defaults so consuming apps would just have to plug it in to the pom.xml. It lead us down a few options which we described below and in the end landed on #3 of Injecting ConfigurableApplicationContext in one of our auto configuration classes.</p>
<h2>Option 1 - PropertyPlaceholderConfigurer</h2>
<p>As martypitt / swagger-springmvc states in the documentation you can configure the properties programmatically with the PropertyPlaceholderConfigurer. We need the properties in&nbsp;<a href="http://docs.spring.io/spring/docs/current/javadoc-api/org/springframework/core/env/Environment.html" rel="external nofollow noreferrer">spring's Environment class</a>, a class that manages profiles and properties, but PropertyPlaceholderConfigurer is not able to add properties to environment. PropertySourcesPlaceholderConfigurer uses Environment and not vice versa. Also, we wanted this in the spring boot module, not all consuming rest applications. In case this works for you, this is what the configuration would look like:</p>
<pre class="prettyprint linenums"><code> @Bean<br />
public static PropertyPlaceholderConfigurer swaggerProperties() throws UnknownHostException {

    // Swagger expects these to property values to be replaced. We don't want to propagate these to consumers of<br />
    // this configuration, so we derive reasonable defaults here and configure the properties programmatically.<br />
    Properties properties = new Properties();<br />
    properties.setProperty("documentation.services.basePath", servletContext.getContextPath());<br />
    // this property will be overridden at runtime, so the value here doesn't matter<br />
    properties.setProperty("documentation.services.version", "REPLACE-ME");

    PropertyPlaceholderConfigurer configurer = new PropertyPlaceholderConfigurer();<br />
    configurer.setProperties(properties);<br />
    configurer.setIgnoreUnresolvablePlaceholders(true);<br />
    return configurer;<br />
}</code></pre>
<h2>Option 2 - Implementing ApplicationContextInitializer</h2>
<p><a href="http://docs.spring.io/spring/docs/current/javadoc-api/org/springframework/context/ApplicationContextInitializer.html" rel="external nofollow noreferrer">ApplicationContextInitializer</a>&nbsp;is a call back interface for initializing ConfigurableApplicationContext prior to being refreshed typically used within web applications that require some programmatic initialization of the application context. So this would work great, on start up we can set the two properties but what it doesn't give us is the ability to get hold of a&nbsp;<a href="http://docs.oracle.com/javaee/6/api/javax/servlet/ServletContext.html" rel="external nofollow noreferrer">ServletContext</a>&nbsp;through&nbsp;<a href="http://docs.spring.io/spring/docs/current/javadoc-api/org/springframework/web/context/ServletContextAware.html" rel="external nofollow noreferrer">ServletContextAware</a>&nbsp;because it fires to early on in the spring lifecycle.</p>
<p>So if your application will deploy to a single environment or if you want to require each of your applications to specify the properties required in the application.properties file, this solution might work for you. It would look something like this:</p>
<p>In your spring.factories within your boot starter project you would need to add:</p>
<pre class="prettyprint linenums"><code>org.springframework.context.ApplicationContextInitializer=com.levelup.SomeInitializer</code></pre>
<p>Then add the following class</p>
<pre class="prettyprint linenums"><code>public class SwaggerApplicationContextInitializer implements<br />
        ApplicationContextInitializer&lt;ConfigurableApplicationContext&gt; {

    @Override<br />
    public void initialize(ConfigurableApplicationContext applicationContext) {

        MutablePropertySources propertySources = applicationContext<br />
                .getEnvironment().getPropertySources();

        Map&lt;String, Object&gt; propertyMap = new HashMap&lt;String, Object&gt;();<br />
        propertyMap.put("documentation.services.basePath",<br />
                "http://localhost:8080/participant");<br />
        propertyMap.put("documentation.services.version", "REPLACE-ME");

        propertySources.addFirst(new MapPropertySource(<br />
                "documentation.services", propertyMap));

    }<br />
}</code></pre>
<h2>Option 3 - Injecting ConfigurableApplicationContext</h2>
<p>At the end of the day this solution may not be spring certified and there probably another way to do it but worked.&nbsp;<a href="http://docs.spring.io/spring/docs/current/javadoc-api/org/springframework/context/ConfigurableApplicationContext.html" rel="external nofollow noreferrer">ConfigurableApplicationContext class</a>provides facilities to configure an application context in addition to the application context client methods. So we created a class that implements InitializingBean that allows us to react once all their properties have been set. It allows us to configure the properties need and then add them to the environment so when the DocumentationConfig looks for them, they are available.</p>
<pre class="prettyprint linenums"><code>@Configuration<br />
@AutoConfigureBefore(SwaggerAutoConfiguration.class)<br />
@EnableConfigurationProperties({ SwaggerBeanProperties.class })<br />
public class SwaggerPropertiesAutoConfiguration implements InitializingBean,<br />
        ServletContextAware {

    private ServletContext servletContext;

    @Autowired<br />
    ConfigurableApplicationContext applicationContext;

    @Autowired<br />
    SwaggerBeanProperties swaggerBeanProperties;

    @Override<br />
    public void afterPropertiesSet() throws Exception {

        MutablePropertySources propertySources = applicationContext<br />
                .getEnvironment().getPropertySources();

        Map&lt;String, Object&gt; propertyMap = new HashMap&lt;String, Object&gt;();<br />
        propertyMap.put("documentation.services.basePath",<br />
                getDocumentBasePath());

        propertyMap.put("documentation.services.version", getDocumentVersion());

        propertySources.addFirst(new MapPropertySource(<br />
                "documentation.services", propertyMap));

    }

    private String getDocumentBasePath() {

        if (swaggerBeanProperties.getBasePath() != null) {<br />
            return swaggerBeanProperties.getBasePath();<br />
        } else {<br />
            return servletContext.getContextPath();<br />
        }<br />
    }

    private String getDocumentVersion() {

        if (swaggerBeanProperties.getVersion() != null) {<br />
            return swaggerBeanProperties.getVersion();<br />
        } else {<br />
            return "1.0";<br />
        }<br />
    }

    @Override<br />
    public void setServletContext(ServletContext servletContext) {<br />
        this.servletContext = servletContext;<br />
    }<br />
}</code></pre>
<p>We all have heard it before, "we don't want the base configuration" so we created a @ConfigurationProperties class that will look for the properties and will be injected into SwaggerPropertiesAutoConfiguration above. If properties are set in the application we will apply them, otherwise we will look for the defaults in hopes to create consistency across all apps.</p>
<pre class="prettyprint linenums"><code>@AutoConfigureBefore(SwaggerPropertiesAutoConfiguration.class)<br />
@ConfigurationProperties(name = "documentation.services", ignoreUnknownFields = true)<br />
public class SwaggerBeanProperties  {

    private String basePath;<br />
    private String version;

    public String getBasePath() {<br />
        return basePath;<br />
    }<br />
    public void setBasePath(String basePath) {<br />
        this.basePath = basePath;<br />
    }<br />
    public String getVersion() {<br />
        return version;<br />
    }<br />
    public void setVersion(String version) {<br />
        this.version = version;<br />
    }<br />
}</code></pre>
<p>The last class was simply to import the DocumentationConfig.class</p>
<pre class="prettyprint linenums"><code>@Configuration<br />
@Import(DocumentationConfig.class)<br />
public class SwaggerAutoConfiguration  {<br />
}</code></pre>
<p>Finally, the spring.factories</p>
<pre class="prettyprint linenums"><code># Auto Configure<br />
org.springframework.boot.autoconfigure.EnableAutoConfiguration=\<br />
boot.web.swagger.autoconfigure.SwaggerAutoConfiguration,\<br />
boot.web.swagger.autoconfigure.SwaggerPropertiesAutoConfiguration

org.springframework.context.ApplicationContextInitializer=</code></pre>
<p>Spring-boot was made to solve the "we have ever which way to configure an application" syndrome but occasionally you still might have get dirty. It might not be perfect but it works for now. If you have suggestions or other ways this could be handled, let me know.</p>
<p>Configure swagger with spring boot&nbsp;posted by&nbsp;<a href="https://plus.google.com/101977895205093468251?rel=author" rel="external nofollow noreferrer">Justin Musgrove</a>&nbsp;on&nbsp;16 April 2014</p>
<p>http://www.leveluplunch.com/blog/2014/04/16/spring-boot-swagger-springmvc-configuration/</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8ox7e18.html">MySQL数据复制的校验</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okl16l9.html">MVC   &commat;Html&period;DropDownListFor  默认值</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z3k3z9.html">PCB的阻抗控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yroyeq.html">（转）C&sol;C&plus;&plus;中static关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kz7n49.html">读懂Java中的Socket编程&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yyydg8.html">uva103&lpar;最长递增序列，dag上的最长路）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv116mxq.html">ASP&period;NET MVC5 插件机制中插件的简单实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ywrj08.html">Django解决 &amp;&num;39&semi;ascii&amp;&num;39&semi; codec can&amp;&num;39&semi;t encode characters in position</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zp20j9.html">HDU 2176 取&lpar;m堆&rpar;石子游戏  尼姆博弈</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdv6z79.html">Python中range&lpar;&rpar;和len&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjezl28.html">百度地图SDK3&period;4的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlle5exq.html">xilinx Vivado的使用详细介绍（2）：创建工程、添加文件、综合、实现、管脚约束、产生比特流文件、烧写程序、硬件验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvvlpz8.html">Storm知识点笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll55xkq.html">windows 系统纯净版官网下载地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/960kwe39.html">Android：注册登录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjpvvvq.html">揭秘uc浏览器二</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnndyljq.html">GCC编译命令常用选项</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn6gl4q.html">使用CSS进行定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p317w8.html">关于php优化 你必须知道的一些事情</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj40gp8.html">Leetcode 62</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j04ge0q.html">pull解析和sax解析的差别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1g6l69.html">从实践谈iOS生命周期</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j047xeq.html">模板--&amp;gt&semi;中国剩余定理&lbrack;互质版本&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xkkom8.html">Jquery小东西收集</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok06z19.html">My&period;Ioc 代码示例&mdash;&mdash;使用观察者机制捕获注册项状态的变化</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vx6248.html">启动php-fpm时报错</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde472z9.html">想加入一行代码吗？使用&amp;lt&semi;code&amp;gt&semi;标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7my6xxq.html">MySQL 选择数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjozpy9.html">&lpar;转&rpar;C&plus;&plus;静态库与动态库</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok07d59.html">rhel-server-6&period;2-i386安装gcc、g&plus;&plus;步骤</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
